Unit DE04R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AME2R_p, DE04RD_p, DE04RM_p, DE04RP_p, DE04RQ_p, UTDE20_p;

procedure DE04R(FA :Proc_F3_DE; FI :Proc_F3_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; EPS :Real; P :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var XP :Real; var YP :Array of Real;
                var A :Array of Real; var E1 :Array of Real;
                var E2 :Array of Real; var E3 :Array of Real;
                var W1 :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var R4 :Array of Real; var R5 :Array of Real;
                var R6 :Array of Real; var YD :Array of Real;
                var IERR :Integer);

implementation

procedure DE04R(FA :Proc_F3_DE; FI :Proc_F3_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; EPS :Real; P :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var XP :Real; var YP :Array of Real;
                var A :Array of Real; var E1 :Array of Real;
                var E2 :Array of Real; var E3 :Array of Real;
                var W1 :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var R4 :Array of Real; var R5 :Array of Real;
                var R6 :Array of Real; var YD :Array of Real;
                var IERR :Integer);
var
I :Integer;
EPS1,XT :Real;
BULD,BULHM :Boolean;
C :Array [0..6] of Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230;
begin
IERR := 0;
EPS1 := EPS/32.0;
BULD := True;
BULHM := False;
if ( JSTART <>  -1 ) 
 then goto _20;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_10:
 end;
X := XP;
_20:
C[0] := 2.0*H/3.0;
C[1] := H/2.0;
C[2] := H/3.0;
C[3] := H/4.0;
C[4] := H/6.0;
C[5] := H/12.0;
C[6] := 3.0*H/4.0;
FA(A,X + C[1],M);
AME2R(A,C[3],M,E1,R1,E2,E3);
DE04RQ(M,E1,E2);
DE04RQ(M,E2,E3);
FA(W1,X,M);
DE04RD(M,W1,A);
FI(R1,X,M);
DE04RP(M,W1,YX,R1,R5);
FI(R1,X + C[1],M);
DE04RM(M,E2,R1,R2);
for I:=1 to M do
 begin
  R2[I-1] := R2[I-1]*H;
_30:
 end;
DE04RP(M,E3,YX,R2,R3);
FA(W1,X + H,M);
DE04RD(M,W1,A);
FI(R2,X + H,M);
DE04RP(M,W1,R3,R2,R4);
for I:=1 to M do
 begin
  R4[I-1] := R4[I-1]*C[4];
_40:
 end;
for I:=1 to M do
 begin
  R3[I-1] := R1[I-1]*C[0];
_50:
 end;
DE04RP(M,E2,R3,R4,R4);
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R5[I-1]*C[4];
_60:
 end;
DE04RP(M,E3,R3,R4,YD);
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R5[I-1]*C[3];
_70:
 end;
DE04RM(M,E1,R3,R4);
FI(R3,X + C[3],M);
FA(E3,X + C[3],M);
DE04RD(M,E3,A);
DE04RP(M,E3,R4,R3,R6);
for I:=1 to M do
 begin
  R4[I-1] := R6[I-1]*C[3];
_80:
 end;
DE04RP(M,E1,YX,R4,R4);
DE04RP(M,E3,R4,R3,R3);
for I:=1 to M do
 begin
  R4[I-1] := R1[I-1]*C[5];
_90:
 end;
for I:=1 to M do
 begin
  R3[I-1] := (R6[I-1] + R3[I-1])*C[4];
_100:
 end;
DE04RP(M,E1,R3,R4,R6);
for I:=1 to M do
 begin
  R3[I-1] := YX[I-1] + R5[I-1]*C[5];
_110:
 end;
DE04RP(M,E2,R3,R6,R6);
for I:=1 to M do
 begin
  R3[I-1] := R6[I-1] + R1[I-1]*C[3];
_120:
 end;
DE04RM(M,E1,R3,R4);
FA(E3,X + C[6],M);
DE04RD(M,E3,A);
FI(R3,X + C[6],M);
DE04RP(M,E3,R4,R3,R5);
for I:=1 to M do
 begin
  R4[I-1] := R5[I-1]*C[3];
_130:
 end;
DE04RP(M,E1,R6,R4,R4);
DE04RP(M,E3,R4,R3,R3);
DE04RM(M,E1,R3,R4);
for I:=1 to M do
 begin
  R4[I-1] := R4[I-1]*C[1];
_140:
 end;
DE04RP(M,E2,R6,R4,R4);
DE04RP(M,W1,R4,R2,R2);
for I:=1 to M do
 begin
  R2[I-1] := R2[I-1]*C[5];
_150:
 end;
for I:=1 to M do
 begin
  R3[I-1] := (R5[I-1] + R3[I-1])*C[4];
_160:
 end;
DE04RP(M,E1,R3,R2,R4);
for I:=1 to M do
 begin
  R2[I-1] := R6[I-1] + R1[I-1]*C[5];
_170:
 end;
DE04RP(M,E2,R2,R4,R6);
for I:=1 to M do
 begin
  XT := (R6[I-1] - YD[I-1])/15.0;
  R1[I-1] := XT;
  if ( Abs(R6[I-1]) >=  P ) 
   then XT := XT/Abs(R6[I-1]);
  if ( Abs(XT) >  EPS1 ) 
   then BULD := False;
  if ( Abs(XT) >=  EPS ) 
   then goto _210;
_180:
 end;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_190:
 end;
XP := X;
for I:=1 to M do
 begin
  YX[I-1] := R6[I-1];
_200:
 end;
X := X + H;
if ( BULD ) 
 then H := H*2.0;
goto _230;
_210:
if ( BULHM ) 
 then goto _220;
H := H/2.0;
BUL := False;
if ( Abs(H) >  Abs(HMIN) ) 
 then goto _20;
H := Sign(HMIN,H);
BULHM := True;
goto _20;
_220:
IERR := 65;
UTDE20(IERR,4);
_230:
JSTART := 1;
end;

end.
